;-------- keys and mouse --------------
Global MDleft, MDright, MDmid
Global MHleft, MHright, MHmid
Global MRleft, MRright, MRmid
Global mx%, my%, mxs#, mys#, mzs#
Global kdLeft, kdRight, kdForward, kdBackward
Global kd_W, kd_A, kd_S, kd_D
Global khESC, kh_E, kh_SPACE

;------------ For map -----------------
Global terrain, CurMap$

Const mapsDir$ = "maps/"
Const modelsDir$ = "models/"

Type levelInfo
	Field mesh, path$
	Field view%
	Field x#, y#, z#
	Field sx#, sy#, sz#
End Type

Const MESH_TYPE=1, AMESH_TYPE=2, SPRITE_TYPE=3, POINT_TYPE=4, PORTAL_TYPE=5

Type PortalInfo
	Field x#, y#, z#
	Field distX#, distY#, distZ#
	Field destMap$, destPoint$
End Type

Type PointInfo
	Field name$
	Field x#, y#, z#
	Field yaw#
End Type

;-------- For Recources ---------------
Type ResInfo
	Field FILE$
	Field FTYPE
	Field SIZE#, PERC#
	Field ID
	Field STATE
End Type

Type CopyResInfo
	Field ID
	Field Res.ResInfo
End Type

Type ResWaiting
	Field COPY
	Field ResC.CopyResInfo
	Field Res.ResInfo
End Type

Const ST_WAIT=1, ST_LOAD=2

Const REM_B% = 0
Const REM_KB% = 1
Const REM_MB% = 1

Global DrawLoading=False
Global WaitTotalSize#, curPERC#

Global LBarX#, LBarY#, LBarW#, LBarH#

;--------- for camera -----------------
Global camera, campiv
Global camYaw#, camPitch#, destYaw#, destPitch#
Global CamHeight#, CamDist#, CamLag#

;+++++++++++++++++++++ For HERO +++++++++++++++++++++++
Type HeroInfo
	Field entity, model
	Field spLong#, spTurn#
	Field state
	Field healph#
	Field GRAVITY#
	Field destYaw#, Yaw#
	Field animFlag, anim
	;Field enemy.BotInfo
	Field power#
End Type
Dim Hero.HeroInfo(1)

Const ST_STAY=0, ST_MOVE=1, ST_ATTACK=2, ST_STUN=3

;============    =====================
;======||===== BEGIN    DWARF    ANIMATION  ====||==================
Const dwf_walk = 1;  
Const dwf_run = 2;   
Const dwf_jump = 3;  
Const dwf_jumpOnSpot = 4;    
Const dwf_crouchDown = 5;   
Const dwf_stayCrouched = 6;   
Const dwf_getUp = 7;   
Const dwf_idleButtle1 = 8;   
Const dwf_idleButtle2 = 9;   
Const dwf_attackSwipeAxe = 10;  
Const dwf_attackJumpOverhead = 11;   
Const dwf_attack360spinBack = 12;   360  
Const dwf_attack2swipes = 13;  
Const dwf_attackStab = 14;  -
Const dwf_block = 15; 
Const dwf_dieForwards = 16;    
Const dwf_dieBackwards = 17;    
Const dwf_nodYES = 18;  
Const dwf_nodNO = 19;  
Const dwf_idle1 = 20;   
Const dwf_idle2 = 21;   

Global ActiveHero = -1

;--------------- For Bots / NPC ---------------
Type BotInfo
	Field entity
	Field state
	Field healph#, dead, distZakop#, TimeDead
	Field anim, animSpeed[3], m.Monsters, stunFlag%, attacked%
	Field startX#, startZ#, targetX#, targetZ#
	Field speed#, time%
End Type

Const mtr_animCnt = 4
Const mtr_stay = 1, mtr_run = 2, mtr_attack = 3, mtr_stun = 4

Type Monsters
	Field name$
	Field model
	Field anim[mtr_animCnt], animSpeed#[mtr_animCnt]
End Type



;------------------------------------------------------

Function UpdateInput()
	;   
	mx = MouseX()
	my = MouseY()
	mxs = MouseXSpeed()
	mys = MouseYSpeed()
	mzs = MouseZSpeed()
	;   
	MRleft = MDleft And (Not MouseDown(1))
	MRright = MDright And (Not MouseDown(2))
	MRmid = MDmid And (Not MouseDown(3))
	;   
	MDleft = MouseDown( 1 )
	MDright = MouseDown( 2 )
	MDmid = MouseDown( 3  )
	;   
	MHleft = MouseHit( 1 )
	MHright = MouseHit( 2 )
	MHmid = MouseHit( 3 )
	;   
	khESC = KeyHit( 1 )
	kh_E = KeyHit( 18 )
	kh_SPACE = KeyHit( 57 )
	kdLeft = KeyDown( 203 )
	kdRight = KeyDown( 205 )
	kdForward = KeyDown( 200 )
	kdBackward = KeyDown( 208 )
	kd_W = KeyDown( 17 )
	kd_A = KeyDown( 30 )
	kd_S = KeyDown( 31 )
	kd_D = KeyDown( 32 )
End Function
;/////////////////////////////////////////////////////////////
Function HeroCreate(num%, x#, y#, z#, yaw#)
	Hero(num) = New HeroInfo
	Hero(num)\entity = CreatePivot()
	Hero(num)\model = LoadAnimMesh("models/dwarf/dwarf1.b3d")
	
	ExtractAnimSeq (Hero(num)\model,2,14)      ;1 dwf_walk
	ExtractAnimSeq (Hero(num)\model,16,26)     ;2 dwf_run
	ExtractAnimSeq (Hero(num)\model,28,40)     ;3 dwf_jump
	ExtractAnimSeq (Hero(num)\model,42,54)     ;4 dwf_jumpOnSpot
	ExtractAnimSeq (Hero(num)\model,56,59)     ;5 dwf_crouchDown
	ExtractAnimSeq (Hero(num)\model,60,69)     ;6 dwf_stayCrouched
	ExtractAnimSeq (Hero(num)\model,70,74)     ;7 dwf_getUp
	ExtractAnimSeq (Hero(num)\model,75,88)     ;8 dwf_idleButtle1
	ExtractAnimSeq (Hero(num)\model,90,110)    ;9 dwf_idleButtle2
	ExtractAnimSeq (Hero(num)\model,112,126)   ;10 dwf_attackSwipeAxe
	ExtractAnimSeq (Hero(num)\model,128,142)   ;11 dwf_attackJumpOverhead
	ExtractAnimSeq (Hero(num)\model,144,160)   ;12 dwf_attack360spinBack
	ExtractAnimSeq (Hero(num)\model,162,180)   ;13 dwf_attack2swipes
	ExtractAnimSeq (Hero(num)\model,182,192)   ;14 dwf_attackStab
	ExtractAnimSeq (Hero(num)\model,194,210)   ;15 dwf_block
	ExtractAnimSeq (Hero(num)\model,212,227)   ;16 dwf_dieForwards
	ExtractAnimSeq (Hero(num)\model,230,251)   ;17 dwf_dieBackwards
	ExtractAnimSeq (Hero(num)\model,253,272)   ;18 dwf_nodYES
	ExtractAnimSeq (Hero(num)\model,274,290)   ;19 dwf_nodNO
	ExtractAnimSeq (Hero(num)\model,292,325)   ;20 dwf_idle1
	ExtractAnimSeq (Hero(num)\model,327,360)   ;21 dwf_idle2
	
	Hero(num)\anim = dwf_idle2
	Animate( Hero(num)\model,1,0.3,dwf_idle2, 10 )
	
	;EntityParent(Hero(num)\model, Hero(num)\entity)
	
	PositionEntity( Hero(num)\entity, x, y, z, 1 )
	Hero(num)\destYaw# = yaw
	Hero(num)\Yaw# = Hero(num)\destYaw#
	RotateEntity(Hero(num)\entity, 0, Hero(num)\Yaw#, 0)
	
	EntityType( Hero(num)\entity, heroCol )
	EntityRadius( Hero(num)\entity, 10 )
	;TranslateEntity( Hero(num)\model, 0, -10, 0, 1 )
	
	RotateEntity(Hero(num)\model, 0, Hero(num)\Yaw#, 0)
	PositionEntity( Hero(num)\model, x, y-10, z, 1 )
	
	Hero(num)\power = 35
	
	ActiveHero = num
End Function
;/////////////////////////////////////////////////////////////
Function SetHeroPosition(x#=0, y#=0, z#=0, yaw#=0)
	EntityType(Hero(ActiveHero)\entity, 0)
	PositionEntity(Hero(ActiveHero)\entity, x, y, z, 1)
	Hero(ActiveHero)\destYaw# = yaw
	Hero(ActiveHero)\Yaw# = Hero(ActiveHero)\destYaw#
	RotateEntity(Hero(ActiveHero)\entity, 0, Hero(ActiveHero)\Yaw#, 0)
	EntityType(Hero(ActiveHero)\entity, heroCol)
End Function
;/////////////////////////////////////////////////////////////
Function HeroMove(num%)
	Local colTerr, n%, cntCol%, colY#, colNX#, colNY#, colNZ#, colEnt%
	Local heroX#, heroY#, heroZ#
	Local dx#, dy#, dz#
	Local animMode%, animSpeed#, animTrans#
	Local dYaw#, koef#, diffangles#, naklon#
	Local pick%, pickedName$
	Local b.BotInfo
	Local NaZemle = False
	Local GravGround# = 1, maxGravAir# = 10
	Local accelGrav# = 0.06

;-----  --------
	If CountCollisions(Hero(num)\entity) > 0 Then
		Hero(num)\GRAVITY = -GravGround
		For n = 1 To CountCollisions(Hero(num)\entity)
			colEnt = CollisionEntity(Hero(num)\entity, n)
			If GetEntityType(colEnt) = terrainCol Then
				colNX# = colNX# + CollisionNX(Hero(num)\entity, n)
				colNY# = colNY# + CollisionNY(Hero(num)\entity, n)
				colNZ# = colNZ# + CollisionNZ(Hero(num)\entity, n)
				cntCol = cntCol + 1
			EndIf
			If NaZemle = False Then
				colY = CollisionY(Hero(num)\entity, n)-EntityY(Hero(num)\entity, 1)
				If colY < 0.5 Then NaZemle = True
			EndIf
		Next
		colNX# = colNX# / cntCol
		colNY# = colNY# / cntCol
		colNZ# = colNZ# / cntCol
		AlignToVector(Hero(num)\entity, colNX, colNY, colNZ, 1)
	Else
		RotateEntity( Hero(num)\entity, 0, Hero(num)\Yaw, EntityRoll(Hero(num)\entity,1) )
		If Hero(num)\GRAVITY > -maxGravAir Then Hero(num)\GRAVITY = Hero(num)\GRAVITY - accelGrav
		If Hero(num)\state <> ST_ATTACK Then Hero(num)\state = ST_STAY
	EndIf
	
	animMode = 1
	animSpeed = 0.2
	animTrans = 20
	If NaZemle = True Then
		If (kd_W Or kd_S)=1 Then ;Or kd_A Or kd_D
			Hero(num)\state = ST_MOVE
		Else
			If Hero(num)\state <> ST_ATTACK Then
				Hero(num)\state = ST_STAY
			EndIf
		EndIf
		
		If kd_W=1 Then
			Hero(num)\spLong = Hero(num)\spLong + 0.1
		ElseIf kd_S=1 Then
			Hero(num)\spLong = Hero(num)\spLong - 0.1
		Else
			If Abs(Hero(num)\spLong) > 0.1 Then
				Hero(num)\spLong = Hero(num)\spLong * 0.7
			Else
				Hero(num)\spLong = 0
			EndIf
			Hero(num)\anim = dwf_idle2
			animSpeed = 0.3
		EndIf
		
		Hero(num)\spLong = limit#( Hero(num)\spLong, -1.5, 2 )
		
		If Hero(num)\spLong <> 0 Then
			naklon# = lRound(EntityPitch(Hero(num)\entity, 1),2)
			koef# = naklon / 180
			If Abs(naklon) > 20 Then
				If Hero(num)\spLong > 0 Then
					If koef < 0 Then
						koef = Abs(koef)
						Hero(num)\spLong = Hero(num)\spLong * ((1-koef)*1.5 - koef)
					EndIf
				ElseIf Hero(num)\spLong < 0 Then
					If koef > 0 Then
						koef = Abs(koef)
						Hero(num)\spLong = Hero(num)\spLong * ((1-koef)*1.4 - koef)
					EndIf
				EndIf
			EndIf
		EndIf
		
		Hero(num)\spLong = limit#( Hero(num)\spLong, -1.5, 2 )
		
		If kd_D=1 Then
			Hero(num)\spTurn = Hero(num)\spTurn - 0.1
		ElseIf kd_A=1 Then
			Hero(num)\spTurn = Hero(num)\spTurn + 0.1
		Else
			Hero(num)\spTurn = 0
		EndIf
		
		If MouseDown(1)=1 Then
			If Hero(num)\state <> ST_MOVE Then
				Hero(num)\state = ST_ATTACK
			EndIf
		EndIf
		
		Select Hero(num)\state
			Case ST_STAY :
				Hero(num)\anim = dwf_idle2
				animSpeed = 0.3
			Case ST_MOVE :
				If kd_W=1 Then
					Hero(num)\anim = dwf_run
					animSpeed = 0.2
				ElseIf kd_S=1 Then
					Hero(num)\anim = dwf_walk
					animSpeed = -0.2
				EndIf
			Case ST_ATTACK :
				Hero(num)\anim = dwf_attackSwipeAxe
				animSpeed = 0.2
				animMode = 3
				
				If Animating(Hero(num)\model) = False Then
					Hero(num)\state = ST_STAY
					Hero(num)\anim = dwf_idle2
					animMode = 1
				Else
					If AnimTime(Hero(num)\model) > 7 And (AnimTime(Hero(num)\model) <= (7 + animSpeed)) Then
						heroX = EntityX(Hero(num)\entity, 1)
						heroY = EntityY(Hero(num)\entity, 1)
						heroZ = EntityZ(Hero(num)\entity, 1)
								
						For b.BotInfo = Each BotInfo
							If EntDist(Hero(num)\entity, b\entity) < 2500 Then
								dx = EntityX(b\entity, 1) - heroX
								dy = EntityY(b\entity, 1) - heroY
								dz = EntityZ(b\entity, 1) - heroZ
								dYaw = VectorYaw( dx, dy, dz )
								diffangles# = (ConvertAng(EntityYaw(Hero(num)\entity,1))-ConvertAng(dYaw))
								If Abs(diffangles) < 60 Then
									b\healph = b\healph - Hero(num)\power
									b\stunFlag = True
									b\state = ST_STUN
								EndIf
							EndIf
						Next
					EndIf
				EndIf
		End Select
	EndIf

;-------  ---------	
	If MDright=0 And Hero(num)\spLong<>0 And Hero(num)\state = (ST_STAY Or ST_MOVE) Then
		Hero(num)\spTurn = Hero(num)\spTurn - limit( mxs * 0.4, -5, 5 )
		MoveMouse( GraphWmid, GraphHmid )
	EndIf
	Hero(num)\spTurn = limit#( Hero(num)\spTurn, -4, 4 )
	Hero(num)\destYaw# = Hero(num)\destYaw + Hero(num)\spTurn
	
	RotateEntity( Hero(num)\model, 0, Hero(num)\destYaw, 0, 1)
	;   
	Hero(num)\Yaw = MergeAngles#(EntityYaw(Hero(num)\entity,1),EntityYaw(Hero(num)\model,1),0.75)
	
;-----  ---------
	If AnimSeq(Hero(num)\model) <> Hero(num)\anim Or Hero(num)\animFlag = True Then
		Animate( Hero(num)\model, animMode, animSpeed, Hero(num)\anim, animTrans )
		If Hero(num)\animFlag = True Then Hero(num)\animFlag = False
	EndIf
		
	RotateEntity( Hero(num)\entity, EntityPitch(Hero(num)\entity,1), Hero(num)\Yaw, EntityRoll(Hero(num)\entity,1) )
	RotateEntity( Hero(num)\model, 0, Hero(num)\Yaw, 0, 1)
	PositionEntity( Hero(num)\model, EntityX(Hero(num)\entity,1), EntityY(Hero(num)\entity,1)-10, EntityZ(Hero(num)\entity,1), 1 )
End Function
;/////////////////////////////////////////////////////////////
Function HeroUpdateForces()
	Local h.HeroInfo
	
	For h.HeroInfo = Each HeroInfo
		MoveEntity( h\entity, 0, 0, h\spLong )
		TranslateEntity( h\entity, 0, h\GRAVITY, 0 )
	Next
End Function
;/////////////////////////////////////////////////////////////
Function MakeCamera(yaw#, pitch#=70, height#=45, dist#=60)
	camera = CreateCamera()
	CameraRange camera, 1, 9999
	EntityType camera, cameraCol
	EntityRadius camera, 1.5
	
	SetCameraOptions(yaw#, pitch#, height#, dist#)
End Function
;/////////////////////////////////////////////////////////////
Function SetCameraOptions(yaw#, pitch#=70, height#=45, dist#=60)
	Local heroX#, heroY#, heroZ#
	
	CamHeight# = height
	CamDist# = dist
	destYaw = yaw
	camYaw = destYaw
	destPitch = pitch
	camPitch = destPitch
	
	heroX# = EntityX(Hero(ActiveHero)\entity, 1)
	heroY# = EntityY(Hero(ActiveHero)\entity, 1)
	heroZ# = EntityZ(Hero(ActiveHero)\entity, 1)
	
	PositionEntity(camera, heroX, heroY+CamHeight, heroZ, 1)
	RotateEntity(camera, camPitch, camYaw, 0)
	MoveEntity(camera, 0, 0, -CamDist)
End Function
;/////////////////////////////////////////////////////////////
Function MoveCamera()
	Local heroX#, heroY#, heroZ#
	Local camX#, camY#, camZ#
	Local campivX#, campivY#, campivZ#
	Local maxpitch# = 70
	Local minpitch# = 20
	
	If ActiveHero = -1 Then RuntimeError("Hero not Failed.")
	
	heroX# = EntityX(Hero(ActiveHero)\entity, 1)
	heroY# = EntityY(Hero(ActiveHero)\entity, 1)
	heroZ# = EntityZ(Hero(ActiveHero)\entity, 1)
	camX# = EntityX(camera, 1)
	camY# = EntityY(camera, 1)
	camZ# = EntityZ(camera, 1)
	;  
	If MDright=1 Then
		If MHright = 1 Then
			destYaw# = camYaw
			destPitch# = camPitch
		EndIf
		destYaw# = destYaw# - mxs * 0.5
		destPitch# = destPitch# + mys * 0.5
		If (destPitch > maxpitch) destPitch = maxpitch
		If (destPitch < minpitch) destPitch = minpitch
		
		camYaw = camYaw + ( destYaw - camYaw ) * 0.2
		camPitch = camPitch + ( destPitch - camPitch ) * 0.2
		
		MoveMouse( GraphWmid, GraphHmid )
	;    
	Else
		If MRright=1 Then
			camYaw = EntityYaw(camera,1)
			camPitch = EntityPitch(camera,1)
		EndIf
		dx# = heroX - camX
		dy# = heroY - camY
		dz# = heroZ - camZ
		destYaw = VectorYaw( dx, CamHeight + dy, dz )
		destPitch = VectorPitch( dx, CamHeight + dy, dz )
		If (destPitch > maxpitch) destPitch = maxpitch
		If (destPitch < minpitch) destPitch = minpitch
		camYaw = destYaw
		camPitch = destPitch
	EndIf
	
	;     
	If CamDist >= 50 Then
		Select mzs
			Case 1, -1 :
				CamDist = CamDist - mzs * 10
				If CamDist < 50 Then CamDist = 50
				If CamDist > 200 Then CamDist = 200
		End Select
	EndIf
	;        CamDist
	PositionEntity( camera, heroX, heroY + CamHeight, heroZ, 1 )
	RotateEntity( camera, camPitch, camYaw, 0, 1 )
	MoveEntity( camera, 0, 0, -CamDist )
End Function
;/////////////////////////////////////////////////////////////
Function AddMonster( name$ )
	Local x#, y#
	Local m.Monsters = New Monsters
	m\model = LoadAnimMesh("models/"+name+"/model.b3d")
	HideEntity m\model
	NameEntity(m\model, Handle(m))
	
	m\name$ = name$
	
	;INI_OpenFile("models/"+name+"/Info.ini")
	x# = 1;Float(INI_ReadValue("COLLISION","radX","1"))
	y# = 1;Float(INI_ReadValue("COLLISION","radY","1"))
		EntityBox(m\model, EntityX(m\model)-x, EntityY(m\model)-y, EntityZ(m\model)-x, x*2, y*2, x*2)
		EntityRadius(m\model, x#, y#)
		anim_start = 0;INI_ReadValue("ANIMATION","idle_start","0")
		anim_end = 0;INI_ReadValue("ANIMATION","idle_end","0")
		m\anim[mtr_stay] = ExtractAnimSeq(m\model, anim_start, anim_end)
		m\animSpeed[mtr_stay] = 1;INI_ReadValue("ANIMATION","idle_speed","1")
		anim_start = 0;INI_ReadValue("ANIMATION","run_start","0")
		anim_end = 0;INI_ReadValue("ANIMATION","run_end","0")
		m\anim[mtr_run] = ExtractAnimSeq(m\model, anim_start, anim_end)
		m\animSpeed[mtr_run] = 1;INI_ReadValue("ANIMATION","run_speed","1")
		anim_start = 0;INI_ReadValue("ANIMATION","attack_start","0")
		anim_end = 0;INI_ReadValue("ANIMATION","attack_end","0")
		m\anim[mtr_attack] = ExtractAnimSeq(m\model, anim_start, anim_end)
		m\animSpeed[mtr_attack] = 1;INI_ReadValue("ANIMATION","attack_speed","1")
		anim_start = 0;INI_ReadValue("ANIMATION","stun_start","0")
		anim_end = 0;INI_ReadValue("ANIMATION","stun_end","0")
		m\anim[mtr_stun] = ExtractAnimSeq(m\model, anim_start, anim_end)
		m\animSpeed[mtr_stun] = 1;INI_ReadValue("ANIMATION","stun_speed","1")
	;INI_CloseFile()
End Function
;/////////////////////////////////////////////////////////////
Function CreateBot(name$, x#=0, y#=0, z#=0, yaw#=0)
	Local b.BotInfo = New BotInfo
	b\m.Monsters = Object.Monsters(FindMonster( name$ ))
	If b\m <> Null Then
		b\entity = CopyEntity( b\m\model )
		
		PositionEntity(b\entity, x, y, z)
		RotateEntity(b\entity, 0, yaw, 0)
		
		EntityType(b\entity, botCol)
		EntityPickMode(b\entity, 3)
		NameEntity(b\entity, Handle(b))
		
		b\dead = False
		b\healph = 100
		b\state = ST_STAY
		
		b\time = MilliSecs() + Rand(3,5)*1000
		
		b\startX = x
		b\startZ = z
	Else
		RuntimeError( "monster: "+name+" not found" )
	EndIf
End Function
;/////////////////////////////////////////////////////////////
Function FindMonster( name$ )
	Local m.Monsters
	
	For m.Monsters = Each Monsters
		If m\name = name Then Return Handle(m)
	Next
	Return 0
End Function
;/////////////////////////////////////////////////////////////
Function BotUpdateAI()
	Local b.BotInfo
	Local heroX#, heroY#, heroZ#
	Local animMode%, animSpeed#, animTrans#
	
	animMode = 1
	animSpeed = 0.5
	animTrans = 10
	For b.BotInfo = Each BotInfo
		If b\dead = False Then
			If b\healph <= 0 Then
				b\healph = 0
				b\dead = True
				EntityPickMode(b\entity, 0)
				EntityType(b\entity, botDeadCol)
				EntityRadius(b\entity, 8, 8)
				Animate(b\entity, 3, b\m\animSpeed[mtr_stun], b\m\anim[mtr_stun], 10)
				b\TimeDead = MilliSecs() + 2000
			Else
				Select b\state
					Case ST_STAY :
						b\anim = mtr_stay
						animMode = 2
						animSpeed = b\m\animSpeed[mtr_stay]
						b\stunFlag=False
						
						If MilliSecs() > b\time Then
							b\targetX = b\startX + Rnd(-100, 100)
							b\targetZ = b\startZ + Rnd(-100, 100)
							b\speed = 1 + Rnd(1)
							b\state = ST_MOVE
						EndIf
					Case ST_MOVE :
						If b\attacked = True Then
							b\targetX = EntityX(Hero(ActiveHero)\entity,1)
							b\targetZ = EntityZ(Hero(ActiveHero)\entity,1)
						EndIf
						dyaw# = VectorYaw(b\targetX - EntityX(b\entity), 0, b\targetZ - EntityZ(b\entity))
						yaw# =MergeAngles#(EntityYaw(b\entity,1), dYaw, 0.75)
						RotateEntity(b\entity, 0, yaw, 0)
						
						dist# = Dist2D(EntityX(b\entity), EntityZ(b\entity), b\targetX, b\targetZ)
						If dist < 900.0 Then
							If b\attacked = True Then
								b\state = ST_ATTACK
								b\speed = 0
							Else
								b\anim = mtr_stay
								animMode = 2
								animSpeed = b\m\animSpeed[mtr_stay]
								b\time = MilliSecs() + Rand(3,5)*1000
								b\speed = 0
								b\state = ST_STAY
							EndIf
						Else
							b\anim = mtr_run
							animMode = 1
							animSpeed = b\m\animSpeed[mtr_run]
							If b\attacked = True Then
								If dist > 22500.0 Then
									b\anim = mtr_stay
									animMode = 2
									animSpeed = b\m\animSpeed[mtr_stay]
									b\time = MilliSecs() + Rand(3,5)*1000
									b\speed = 0
									b\state = ST_STAY
									b\attacked = False
								EndIf
							EndIf
						EndIf
					Case ST_ATTACK :
						b\anim = mtr_attack
						animMode = 3
						animSpeed = b\m\animSpeed[mtr_attack]
						
						If Animating(b\entity) = False Then
							b\anim = mtr_stay
							animMode = 2
							animSpeed = b\m\animSpeed[mtr_stay]
							b\speed = 0
							b\state = ST_STAY
							b\attacked = False
						EndIf
					Case ST_STUN :
						b\anim = mtr_stun
						animMode = 3
						animSpeed = b\m\animSpeed[mtr_stun]
						b\speed = 0
						
						If Animating( b\entity ) = False Then
							b\state = ST_STAY
							b\anim = mtr_stay
							animMode = 2
							animSpeed = b\m\animSpeed[mtr_stay]
							b\stunFlag = False
						EndIf
				End Select
				
				Select b\state
					Case ST_STUN, ST_ATTACK :
					Default :
						If EntDist(b\entity, Hero(ActiveHero)\entity) < 10000.0 Then
							b\state = ST_MOVE
							b\speed = 1.5
							b\attacked = True
						EndIf
				End Select
				
				If AnimSeq(b\entity) <> b\anim Or b\stunFlag=True Then
					Animate( b\entity, animMode, animSpeed, b\anim, animTrans )
					If b\stunFlag=True Then b\stunFlag=False
				EndIf
			EndIf
		Else
			For n = 1 To CountCollisions(b\entity)
				colEnt = CollisionEntity(b\entity, n)
				If GetEntityType(colEnt) = terrainCol Then
					nx# = CollisionNX(b\entity, n)
					ny# = CollisionNY(b\entity, n)
					nz# = CollisionNZ(b\entity, n)
					;aAlignToVector(b\entity, nx#, ny#, nz#, 1)
					AlignToVector(b\entity, nx#, ny#, nz#, 3)
					Exit
				EndIf
			Next
		EndIf
	Next
End Function
;/////////////////////////////////////////////////////////////
Function BotsUpdateForces()
	Local b.BotInfo
	
	For b.BotInfo = Each BotInfo
		If b\dead = False Then
			MoveEntity(b\entity, 0, 0, b\speed)
			TranslateEntity( b\entity, 0, -1, 0 )
		Else
			If MilliSecs() < b\TimeDead Then
				TranslateEntity( b\entity, 0, -1, 0 )
			Else
				EntityType(b\entity, 0)
				If b\distZakop < 30 Then
					MoveEntity( b\entity, 0, 0, -0.05)
					b\distZakop = b\distZakop + 0.05
				Else
					FreeEntity( b\entity )
					Delete( b )
				EndIf
			EndIf
		EndIf
	Next
End Function
;/////////////////////////////////////////////////////////////
Function DrawDebug()
	Color( 0, 255, 0 )
	Text( 10, 10, "player X: "+EntityX(Hero(ActiveHero)\entity,1) )
	Text( 10, 30, "player Y: "+EntityY(Hero(ActiveHero)\entity,1) )
	Text( 10, 50, "player Z: "+EntityZ(Hero(ActiveHero)\entity,1) )
	Text( 10, 70, "player Pit: "+EntityPitch(Hero(ActiveHero)\entity,1) )
	Text( 10, 90, "player speed: "+Hero(ActiveHero)\spLong )
	Local b.BotInfo = First BotInfo
	If b <> Null Then
		Text( 10, 110, "bot healph: "+b\healph )
	EndIf
	Text( 10, 130, "player AnimTime: "+AnimTime(Hero(ActiveHero)\model) )
End Function
;/////////////////////////////////////////////////////////////
Function EntDist#(ent1, ent2)
	Local dx#, dy#, dz#
	dx = EntityX(ent1, 1) - EntityX(ent2, 1)
	dy = EntityY(ent1, 1) - EntityY(ent2, 1)
	dz = EntityZ(ent1, 1) - EntityZ(ent2, 1)
	Return (dx*dx + dy*dy + dz*dz)
End Function
;/////////////////////////////////////////////////////////////
Function Dist2D#(x#, z#, x2#, z2#)
	Local dx#, dz#
	dx = x - x2
	dz = z - z2
	Return (dx*dx + dz*dz)
End Function
;/////////////////////////////////////////////////////////////
Function limit#( val#, min#, max# )
	If val > max Then
		Return max
	ElseIf val < min Then
		Return min
	Else
		Return val
	EndIf
End Function
;/////////////////////////////////////////////////////////////
Function AngleTest(ang#, minAng#, maxAng#)
	If Abs(ang) >= minAng And Abs(ang) <= maxAng Then Return 1
	Return 0
End Function
;/////////////////////////////////////////////////////////////
Function ConvertAng#(ang#)
	ang# = ang# Mod 360
	If ang# < 0 Then ang# = ang# + 360
	Return ang#
End Function
;/////////////////////////////////////////////////////////////
Function MergeAngles#(Angle1#,Angle2#,Morph#=.5)
	If Abs(Angle1-Angle2)>180
		If Angle1<Angle2
			Return Angle1-((360-Angle2)+Angle1)*(.5-(Morph-.5))
		Else
			Return Angle2-((360-Angle1)+Angle2)*(.5+(Morph-.5))
		EndIf
	Else
		Return Angle1*(Morph)+Angle2*(1.0-Morph)
	EndIf
End Function
;/////////////////////////////////////////////////////////////
; 1,    
Function PointInRect(x1#, y1#, x2#, y2#, w#, h#)
	Local xw#, yw#

	xw = x2 + w
	yw = y2 + h
	If x1 >= x2 And y1 >= y2 And x1 <= xw And y1 <= yw Then
		Return 1
	EndIf
	Return 0
End Function
;/////////////////////////////////////////////////////////////
Function PointInBox(x1#, y1#, z1#, x2#, y2#, z2#, w#, h#, d#)
	Local xw#, yw#, zw#

	xw = x2 + w
	yw = y2 + h
	zw = z2 + d
	If x1 >= x2 And y1 >= y2 And z1 >= z2 And x1 <= xw And y1 <= yw And z1 <= zw Then
		Return 1
	EndIf
	Return 0
End Function
;/////////////////////////////////////////////////////////////
Function UpdatePortals()
	Local p.PortalInfo, po.PointInfo
	Local result%=0
	Local destMap$, destPoint$
	
	For p.PortalInfo = Each PortalInfo
		If PointInBox(EntityX(Hero(ActiveHero)\entity,1), EntityY(Hero(ActiveHero)\entity,1), EntityZ(Hero(ActiveHero)\entity,1), p\x, p\y, p\z, p\distX, p\distY, p\distZ)=1
			destMap = p\destMap
			destPoint = p\destPoint
			result = 1
			Exit
		EndIf
	Next
	
	If result = 1 Then
		If destMap$ = CurMap$ Then
			For po.PointInfo = Each PointInfo
				If po\name$ = destPoint$ Then
					SetHeroPosition(po\x, po\y#, po\z#, po\yaw#)
					SetCameraOptions(po\yaw#)
					Exit
				EndIf
			Next
		Else
			ClearMap()
			LoadMap(mapsDir+destMap$)
			For po.PointInfo = Each PointInfo
				If po\name$ = destPoint$ Then
					SetHeroPosition(po\x, po\y#, po\z#, po\yaw#)
					SetCameraOptions(po\yaw#)
					Exit
				EndIf
			Next
			Locate( 300, 500 )
			Print("please hit SPACE for start game" )
			While Not KeyHit(57)
			Wend
			Cls
			RenderWorld()
		EndIf
	EndIf
End Function
;/////////////////////////////////////////////////////////////
Function LoadMap(fname$)
	CurMap$ = GetFileName$(fname$)+"."+GetFileExtension$(fname$)
	;
	filein=ReadFile(fname)  
	cnt=ReadInt(filein) ;    
	
	resStart$ = ReadString(filein)
	
	If resStart = "START_RES" Then
		;Print( "------ PRE-READ MAP ------")
		CntRes = ReadInt(filein)
		For n = 1 To CntRes
			ResPath$ = ReadString(filein)
			ResTip% = ReadByte(filein)
			ResCnt% = ReadInt(filein)
			;Print("res: "+ResPath$+" | count: "+ResCnt)
			AddItem(ResPath$, ResTip, ResCnt)
		Next
	EndIf
	
	resStart$ = ReadString(filein)
	If resStart = "END_RES" Then
		;Print("------ END_RES ------")
		InitFonLoading()
	EndIf
	
	Locate( 100, 10 )
	Color( 0, 255, 0 )
	Print( ">>>>>map Name: "+CurMap)
	Color( 255, 255, 255 )
	;Print( "======== START LOAD MAP ==========")
	
	For i=1 To cnt
		Objload(filein, fname$)  
	Next  
	CloseFile filein  
	
	DeInitFonLoading()
	;Print( "========= END LOAD MAP ===========")
	
End Function
;/////////////////////////////////////////////////////////////
Function Objload.levelInfo(filein, fname$)
	Local x#, y#, z#, sx#, sy#, sz#, pitch#, yaw#, roll#, name$
	Local p.PortalInfo, po.PointInfo
	Local obj.levelInfo = New levelInfo
	
	obj\view=ReadByte(filein)
		
	Select obj\view
		Case MESH_TYPE:
			name$ = Lower(ReadString( filein ))
			obj\path$ = ReadString( filein )
			;Print( "Load mesh: "+name$)
			;Print( obj\path$ )
			x = ReadFloat( filein )
			y = ReadFloat( filein )
			z = ReadFloat( filein )
			obj\sx = ReadFloat( filein )
			obj\sy = ReadFloat( filein )
			obj\sz = ReadFloat( filein )
			pitch = ReadFloat( filein )
			yaw = ReadFloat( filein )
			roll = ReadFloat( filein )
			obj\mesh = LoadItem(obj\path$, obj\view);LoadMesh(obj\path$)
			ScaleEntity obj\mesh, obj\sx, obj\sy, obj\sz
			RotateEntity obj\mesh, pitch, yaw, roll
			PositionEntity obj\mesh, x, y, z
			If name$ = "terrain" Then
				EntityType( obj\mesh, terrainCol )
				NameEntity( obj\mesh, "terrain" )
			Else
				EntityType( obj\mesh, staticCol )
			EndIf
		Case POINT_TYPE:
			po.PointInfo = New PointInfo
			po\name$ = ReadString( filein )
			po\x = ReadFloat( filein )
			po\y = ReadFloat( filein )
			po\z = ReadFloat( filein )
			po\yaw = ReadFloat( filein )
		Case PORTAL_TYPE:
			p.PortalInfo = New PortalInfo
			p\destMap$ = ReadString( filein )
			p\destPoint$ = ReadString( filein )
			p\x = ReadFloat( filein )
			p\y = ReadFloat( filein )
			p\z = ReadFloat( filein )
			p\distX = ReadFloat( filein )
			p\distY = ReadFloat( filein )
			p\distZ = ReadFloat( filein )
			obj\mesh = CreateCube()
			EntityAlpha( obj\mesh, 0.5 )
			ScaleEntity( obj\mesh, p\distX, p\distY, p\distZ )
			PositionEntity( obj\mesh, p\x, p\y, p\z )
			p\x = p\x - p\distX
			p\y = p\y - p\distY
			p\z = p\z - p\distZ
			p\distX = p\distX * 2
			p\distY = p\distY * 2
			p\distZ = p\distZ * 2
   End Select
   
   Return obj  
End Function
;/////////////////////////////////////////////////////////////
Function ClearMap()
	Local obj.levelInfo
	
	RemoveAllItems()
	
	For obj.levelInfo = Each levelInfo
		Select obj\view
			Case PORTAL_TYPE
				FreeEntity( obj\mesh )
		End Select
		Delete obj
	Next
	
	Delete Each PortalInfo
	Delete Each PointInfo
	
End Function
;/////////////////////////////////////////////////////////////
Function AddItem(FILE$, FTYPE, cnt=1)
	Local RW.ResWaiting
	Local n
	
	If cnt > 1 Then
		Select FTYPE
			Case MESH_TYPE, AMESH_TYPE, SPRITE_TYPE :
				For n = 1 To cnt
					RW.ResWaiting = New ResWaiting
					RW\COPY = True
					RW\Res.ResInfo = New ResInfo
					RW\Res\FILE = FILE
					RW\Res\FTYPE = FTYPE
					RW\Res\SIZE = FileSize( FILE )
					RW\ResC.CopyResInfo = New CopyResInfo
					RW\ResC\Res = RW\Res
					RW\Res\STATE = ST_WAIT
					WaitTotalSize# = WaitTotalSize# + RW\Res\SIZE
				Next
			Default :
				For n = 1 To cnt
					RW.ResWaiting = New ResWaiting
					RW\COPY = False
					RW\Res.ResInfo = New ResInfo
					RW\Res\FILE = FILE
					RW\Res\FTYPE = FTYPE
					RW\Res\SIZE = FileSize( FILE )
					RW\Res\STATE = ST_WAIT
					WaitTotalSize# = WaitTotalSize# + RW\Res\SIZE
				Next
		End Select
	Else
		RW.ResWaiting = New ResWaiting
		RW\COPY = False
		RW\Res.ResInfo = New ResInfo
		RW\Res\FILE = FILE
		RW\Res\FTYPE = FTYPE
		RW\Res\SIZE = FileSize( FILE )
		RW\Res\STATE = ST_WAIT
		WaitTotalSize# = WaitTotalSize# + RW\Res\SIZE
	EndIf
End Function
;/////////////////////////////////////////////////////////////
Function LoadItem(FILE$, FTYPE)
	Local RW.ResWaiting
	Local ID%
	
	For RW.ResWaiting = Each ResWaiting
		If RW\COPY = True Then
			If RW\ResC\Res\FILE = FILE Then
				DrawText(GraphWmid, GraphH - 230, RW\ResC\Res\FILE, 1, 1, GraphWmid-200, GraphH-250, 400, 50)
				If RW\ResC\Res\STATE = ST_WAIT Then
					If RW\ResC\Res\ID=0 Then
						Select RW\ResC\Res\FTYPE
							Case MESH_TYPE :
								RW\ResC\Res\ID = LoadMesh( FILE )
							Case AMESH_TYPE :
								RW\ResC\Res\ID = LoadAnimMesh( FILE )
						End Select
					EndIf
					If RW\ResC\Res\ID = 0 Then
						DebugLog( "FILE: "+RW\ResC\Res\FILE )
						DebugLog( "File type: "+RW\ResC\Res\FTYPE )
						Stop
					EndIf
					PositionEntity( RW\ResC\Res\ID, 0, -100000, 0 )
					HideEntity( RW\ResC\Res\ID )
					RW\ResC\Res\STATE = ST_LOAD
				EndIf
				RW\ResC\ID = CopyEntity( RW\Res\ID )
				If RW\ResC\ID = 0 Then
					DebugLog( "COPY!!!" )
					DebugLog( "FILE: "+RW\ResC\Res\FILE )
					DebugLog( "File type: "+RW\ResC\Res\FTYPE )
					Stop
				EndIf
				If DrawLoading = True Then
					curPERC = curPERC + RW\ResC\Res\PERC
					UpdateDrawBar(curPERC, LBarX, LBarY, LBarW, LBarH)
				EndIf
				ID = RW\ResC\ID
				Delete RW
				Return ID
			EndIf
		Else
			If RW\Res\FILE = FILE Then
				DrawText(GraphWmid, GraphH - 230, RW\Res\FILE, 1, 1, GraphWmid-200, GraphH-250, 400, 50)
				Select RW\Res\FTYPE
					Case MESH_TYPE :
						RW\Res\ID = LoadMesh( FILE )
					Case AMESH_TYPE :
						RW\Res\ID = LoadAnimMesh( FILE )
				End Select
				If RW\Res\ID = 0 Then
					DebugLog( "FILE: "+RW\Res\FILE )
					DebugLog( "File type: "+RW\Res\FTYPE )
					Stop
				EndIf
				RW\Res\STATE = ST_LOAD
				If DrawLoading = True Then
					curPERC = curPERC + RW\Res\PERC
					UpdateDrawBar(curPERC, LBarX, LBarY, LBarW, LBarH)
				EndIf
				ID = RW\Res\ID
				Delete RW
				Return ID
			EndIf
		EndIf
	Next
End Function
;/////////////////////////////////////////////////////////////
Function RemoveItem( ID% )
	Local hname% = 0
	Local R.ResInfo, RC.CopyResInfo, ResC.CopyResInfo
	Local result%=0
	
	hname = GetHandle( ID% )
	
	R.ResInfo = Object.ResInfo( hname )
	RC.CopyResInfo = Object.CopyResInfo( hname )
	If R <> Null Then
		If R\STATE = ST_LOAD Then
			If R\ID = ID Then
				Select R\FTYPE
					Case MESH_TYPE, AMESH_TYPE, SPRITE_TYPE :
						FreeEntity( R\ID )
				End Select
				Delete( R )
				Return 1
			EndIf
		EndIf
	ElseIf RC <> Null Then
		If RC\Res\STATE = ST_LOAD Then
			If RC\ID = ID Then
				FreeEntity( RC\ID )
				R = RC\Res
				Delete( RC )
				For ResC.CopyResInfo = Each CopyResInfo
					If ResC\Res = R Then
						result = 1
						Exit
					EndIf
				Next
				If result = 0 Then
					FreeEntity( R\ID )
					Delete( R )
				EndIf
				Return 1
			EndIf
		EndIf
	EndIf
	Return 0
End Function
;/////////////////////////////////////////////////////////////
Function RemoveAllItems()
	Local R.ResInfo, RC.CopyResInfo
	
	For RC.CopyResInfo = Each CopyResInfo
		If RC\Res\STATE = ST_LOAD Then
			Select RC\Res\FTYPE
				Case MESH_TYPE, AMESH_TYPE, SPRITE_TYPE :
					FreeEntity( RC\ID )
			End Select
		EndIf
		Delete( RC )
	Next
	
	For R.ResInfo = Each ResInfo
		If R\STATE = ST_LOAD Then
			Select R\FTYPE
				Case MESH_TYPE, AMESH_TYPE, SPRITE_TYPE :
					FreeEntity( R\ID )
			End Select
		EndIf
		Delete( R )
	Next
	
	Delete Each ResWaiting
	WaitTotalSize# = 0
End Function
;/////////////////////////////////////////////////////////////
Function GetHandle( ID% )
	Local HNDL% = 0
	Local R.ResInfo, RC.CopyResInfo
	For R.ResInfo = Each ResInfo
		If R\ID% = ID% Then HNDL% = Handle( R.ResInfo ) : Return HNDL%
	Next
	For RC.CopyResInfo = Each CopyResInfo
		If RC\ID% = ID% Then HNDL% = Handle( RC.CopyResInfo ) : Return HNDL%
	Next
	Return 0
End Function
;/////////////////////////////////////////////////////////////
Function InitFonLoading()
	SetPercantage()
	DrawLoading = True
	curPERC = 0
	LBarX = GraphWmid - GraphW*0.3
	LBarY = GraphH - 200
	LBarW = GraphW*0.6
	LBarH = 30
	
	Cls
	SetBuffer( FrontBuffer() )
	Cls
	UpdateDrawBar(curPERC, LBarX, LBarY, LBarW, LBarH)
End Function
;/////////////////////////////////////////////////////////////
Function DeInitFonLoading()
	DrawLoading = False
	curPERC = 0
	
	Delete Each ResWaiting
	
	SetBuffer( BackBuffer() )
End Function
;/////////////////////////////////////////////////////////////
Function GetWaitTotalSize#(REM%=1)
	Select REM%
		Case REM_B
			Return WaitTotalSize#
		Case REM_KB
			Return WaitTotalSize#/1024
		Case REM_MB
			Return WaitTotalSize#/1024/1024
		Default
			Return WaitTotalSize#/1024
	End Select
End Function
;/////////////////////////////////////////////////////////////
Function SetPercantage()
	Local RW.ResWaiting
	
	For RW.ResWaiting = Each ResWaiting
		If RW\COPY = True Then
			RW\ResC\Res\PERC = RW\ResC\Res\SIZE * 100 / WaitTotalSize#
		Else
			RW\Res\PERC = RW\Res\SIZE * 100 / WaitTotalSize#
		EndIf
	Next
End Function
;/////////////////////////////////////////////////////////////
Function UpdateDrawBar(perc#, x#, y#, width#, height#)
	Local WidthBar# = (width - 16) * 0.01 * perc
	Local strPERC$ = Str( lRound(perc#,0) )
	
	Color( 255, 255, 255 )
	Rect( x#, y#, width#, height#, 1 )
	Color( 0, 0, 0 )
	Rect( x#+6, y#+6, width#-12, height#-12, 1 )
	
	Color( 255, 255, 255 )
	Rect( x+8, y#+8, WidthBar, height#-16, 1 )
	
	Color( 0, 255, 0 )
	Locate( x+width*0.5-10, y+height*0.5-FontHeight()/2 )
	Print( strPERC )
	
End Function
;/////////////////////////////////////////////////////////////
Function DrawText(x#, y#, name$, CenterX=False, CenterY=False, x2#=0, y2#=0, w#=0, h#=0, r%=255, g%=255, b%=255)
	Local NameWidth# = StringWidth(name)
	Local NameHeight# = StringHeight(name)
	
	Color( 0, 0, 0 )
	If w=0 And h=0 Then
		Rect( x-NameWidth*0.5*CenterX, y-NameHeight*0.5*CenterY, NameWidth, NameHeight )
	Else
		Rect( x2, y2, w, h )
	EndIf
	Locate( x-NameWidth*0.5*CenterX, y-NameHeight*0.5*CenterY )
	Color( r, g, b )
	Print( name$ )
End Function
;/////////////////////////////////////////////////////////////
Function lRound#(a#,fnum=2)
     a#=a#* 10^fnum
     b%=a
     a#=b / 10^fnum
     Return a
End Function
;/////////////////////////////////////////////////////////////
Function GetFileExtension$(FileName$)
	Local c$
	
    For i=Len(FileName) To 1 Step -1
		c$=Mid(FileName,i,1)
		If c="." Then
			Exit
		EndIf
	Next
	Return Right(FileName,Len(FileName)-i)
End Function
;/////////////////////////////////////////////////////////////
Function GetFileName$(FileName$)
	Local c$
	Local NwEXT$
	
	For i=Len(FileName) To 1 Step -1
		c$=Mid(FileName,i,1)
		If c="\" Or c="/" Then
			Exit
		EndIf
    Next
	EXT$=GetFileExtension(FileName$)
    NwEXT$=Right(FileName,Len(FileName)-i)
    Return Left(NwEXT,Len(NwEXT)-Len(EXT)-1)
End Function
;/////////////////////////////////////////////////////////////
Function GetFileParentDir$(FileName$)
	Local c$
	
    For i=Len(FileName) To 1 Step -1
        c$=Mid(FileName,i,1)
        If c="\"
            Exit
        EndIf
    Next
    Return Left(FileName,i)
End Function
;~IDEal Editor Parameters:
;~F#89#AA#DB#E4#18D#196#19F#1B2#1F0#211#22B#234#2B5#2CD#2DB#2E3#2EA#2F4#2F9#2FF
;~F#30C#317#323
;~C#Blitz3D