;Include "INIFileFuncs.bb"

;INI_OpenFile("GameSettings.ini")
Global GraphW% = 800; INI_ReadValue("GRAPHICS","graphWidth","800")
Global GraphH% = 600; INI_ReadValue("GRAPHICS","graphHeight","600")
Global GraphBits% = 32; INI_ReadValue("GRAPHICS","graphBits","32")
Global GraphMode% = 2; INI_ReadValue("GRAPHICS","graphMode","2")
;INI_CloseFile()

Graphics3D GraphW%,GraphH%,GraphBits%,GraphMode%
SetBuffer BackBuffer()
SeedRnd MilliSecs()

;============= global variables =====================
Global Vsync%=False, quit%=False
Global GraphWmid% = GraphW Shr 1 
Global GraphHmid% = GraphH Shr 1
Global ScreenFPS%, GameScr%
Global debug%=True

;-------- const Collisions ------------
Const heroCol=1, cameraCol=2, terrainCol=3, staticCol=4, botCol=5, botDeadCol=6

Const FPS = 70
Local period = 1000 / FPS 
Local time = MilliSecs() - period
Local elapsed%, ticks, tween#, k

;================= FONTS ============================
Global mainfont = LoadFont( "arial cyr", 20, True )
SetFont( mainfont )

;================ Includes ==========================
Include "includes/OtherFuncs.bb"
;====================================================

lit = CreateLight(1)
RotateEntity lit, 45, 45, 0

Collisions( botCol, terrainCol, 2, 3 )
Collisions( botCol, botCol, 1, 3 )
Collisions( botCol, heroCol, 1, 3 )
Collisions( botDeadCol, terrainCol, 2, 3 )
Collisions( heroCol, botCol, 1, 3 )
Collisions( heroCol, terrainCol, 2, 3 )
Collisions( heroCol, staticCol, 2, 3 )
Collisions( cameraCol, terrainCol, 2, 2 )

Local timefps% = MilliSecs(), rfps%
MoveMouse( GraphWmid, GraphHmid )

LoadMap(mapsDir+"test1.map")
For po.PointInfo = Each PointInfo
	If po\name$ = "start" Then
		HeroCreate(0, po\x, po\y#, po\z#, po\yaw#)
		MakeCamera(po\yaw#)
		AddMonster( "knight" )
		For n = 1 To 10
			CreateBot("knight", po\x-40*n, po\y#, po\z#, po\yaw#)
		Next
		Exit
	EndIf
Next
RenderWorld()
Locate( 300, 500 )
Print("please hit SPACE for start game" )
While Not KeyHit(57)
Wend


;======================= Main Loop ==================================
While quit = False
	UpdateInput()
	If khESC = 1 Then quit = True : Exit
	Repeat
		elapsed=MilliSecs()-time
	Until elapsed
		ticks=elapsed/period
		tween#=Float(elapsed Mod period)/Float(period)
		For k = 1 To ticks
			time=time+period
			;======= Logic =========
			
			HeroUpdateForces()
			BotsUpdateForces()
			;=======================	
			UpdateWorld()
			
			HeroMove(0)
			MoveCamera()
			BotUpdateAI()
		Next
	;========= Draw 3D ===========
	RenderWorld()
	;========= Draw 2D ===========
	Color( 0, 255, 0 )
	SetFont( mainfont )
	Text( GraphW - 100, 15, "FPS: "+ScreenFPS% )
	If debug = True Then
		DrawDebug()
	EndIf
	;=============================
	Flip( Vsync )
	;===========	 FPS
	If MilliSecs()-timefps<1000 Then
		rfps=rfps+1
	Else
		ScreenFPS=rfps
		rfps=0
		timefps=MilliSecs()
	EndIf
	UpdatePortals()
Wend

ClearMap()
End
;~IDEal Editor Parameters:
;~C#Blitz3D